---
product: "AG Grid"
title: "Start/Stop Cell Editing"
description: "This page discusses the different ways in which Cell Editing can be started and stopped."
framework: javascript
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-full-row/"
    - title: "Validation"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-validation/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Start/Stop Cell Editing

This page discusses the different ways in which Cell Editing can be started and stopped.

## Start Editing

Assuming `editable=true` or `editable` has a callback that returns `true` for the Column Definition, editing will start upon any of the following:

- **Edit Key Pressed**: One of the following is pressed: `↵ Enter`, `F2`.
- **Backspace**: The default editor will start and clear the contents of the cell if `Backspace` is pressed on Windows. To mimic this behaviour on MacOS, use the `enableCellEditingOnBackspace=true` grid option.
- **Printable Key Pressed**: Any of the following characters are pressed: `abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!"£$%^&amp;*()_+-=[];\'#,./\|<>?:@~{}`
   The default editor places this character into the edit field so that the user experience is they are typing into the cell.
- **Mouse Double Click**: If the mouse is double-clicked. There is a grid property `singleClickEdit` that will allow single-click to start editing instead of double-click. Another property `suppressClickEdit` will prevent both single-click and double-click from starting the edit; use this if you only want to have your own way of starting editing, such as clicking a button in your custom cell renderer.
- **api.startEditingCell(params)**: If you call `startEditingCell(params)` on the grid API

## Stop Editing

The grid will stop editing when any of the following happen:

- **Callback stopEditing**: The callback `stopEditing` (from the params above) gets called by the editor. This is how your cell editor informs the grid to stop editing.
- **Other Cell Focus**: If focus in the grid goes to another cell, the editing will stop.
- **Enter Key Down**: If the grid receives an `↵ Enter` key press event on the cell. If you do **not** want to stop editing when `↵ Enter` is pressed, then listen for the event and stop propagation so the grid does not act on the event.
- **Escape Key Down**: Similar to `↵ Enter`, if `⎋ Esc` key is pressed, editing will stop. Unlike `↵ Enter`, the `⎋ Esc` action will discard changes rather than taking the new value.
- **Tab Key Down**: Editing will stop, accepting changes, and editing will move to the next cell, or the previous cell if `⇧ Shift` is also pressed.
- **Popup Editor Closed**: If using popup editor, the popup is configured to close if you click outside the editor. Closing the popup triggers the grid to stop editing.
- **gridApi.stopEditing()**: If you call `stopEditing()` on the grid API.

### Start / Stop Events

The following events are fired when editing is started and stopped.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditingStarted` | `CellEditingStartedEvent` |  |  |  |
| `cellEditingStopped` | `CellEditingStoppedEvent` |  |  |  |

## Tab Navigation

While editing, if you hit `⇥ Tab`, the editing will stop for the current cell and start on the next cell. If you hold down `⇧ Shift`+`⇥ Tab`, the same will happen except the previous cell will start editing rather than the next. This is in line with editing data in Excel.

The next and previous cells can also be navigated using the API functions `api.tabToNextCell()` and `api.tabToPreviousCell()`. Both of these methods will return `true` if the navigation was successful, otherwise `false`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `tabToNextCell` | `Function` |  |  |  |
| `tabToPreviousCell` | `Function` |  |  |  |

## Editing API

The grid has the following API methods for editing:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `startEditingCell` | `Function` |  |  |  |
| `stopEditing` | `Function` |  |  |  |
| `isEditing` | `Function` |  |  |  |
| `getEditingCells` | `Function` |  |  |  |
| `getEditRowValues` | `Function` |  |  |  |

If the grid is editing, `getEditingCells()` returns back details of the editing cell(s). The result is an array of objects. If only one cell is editing (the default) then the array will have one entry. If multiple cells are editing (e.g. [Full Row Edit](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing-full-row/)) then the array contains all editing cells.

Below is a code example of using the editing API methods.

```js
// start editing country cell on first row
api.startEditingCell({
    rowIndex: 0,
    colKey: 'country'
});

// stop editing
api.stopEditing();

// print details of editing cell
const cellDefs = api.getEditingCells();
cellDefs.forEach(cellDef => {
    console.log(cellDef.rowIndex);
    console.log(cellDef.column.getId());
    console.log(cellDef.rowPinned);
});
```

The example below illustrates different parts of the editing API. Each button starts editing the 'Last Name' column of the first row with the following differences:

- `edit()`: Normal editing start.
- `edit(Backspace)`: Edit as if delete button was pressed (clears contents first).
- `edit('T')`: Edit as if 'T' was pressed (places 'T' into cell).
- `edit(top)`: Edits top pinned row.
- `edit(bottom)`: Edits bottom pinned row.

The example also demonstrates the following buttons for edit navigation:

- `stop()`: Stops editing.
- `next()`: Edits the next cell.
- `previous()`: Edits the previous cell.

Finally, the example also demonstrates querying which cell is editing:

- `which()`: If the grid is editing, prints to the console which cell is in edit mode.

Events are logged in the developer console.

#### Cell Editing

```ts
import {
  CellEditingStartedEvent,
  CellEditingStoppedEvent,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  PinnedRowModule,
  RowEditingStartedEvent,
  RowEditingStoppedEvent,
  RowPinnedType,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  PinnedRowModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "firstName" },
    { field: "lastName" },
    { field: "gender" },
    { field: "age" },
    { field: "mood" },
    { field: "country" },
    { field: "address", minWidth: 550 },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 110,
    editable: true,
  },
  rowData: getData(),
  pinnedTopRowData: getPinnedTopData(),
  pinnedBottomRowData: getPinnedBottomData(),
  onRowEditingStarted: (event: RowEditingStartedEvent) => {
    console.log("never called - not doing row editing");
  },
  onRowEditingStopped: (event: RowEditingStoppedEvent) => {
    console.log("never called - not doing row editing");
  },
  onCellEditingStarted: (event: CellEditingStartedEvent) => {
    console.log("cellEditingStarted");
  },
  onCellEditingStopped: (event: CellEditingStoppedEvent) => {
    console.log("cellEditingStopped");
  },
};

function getPinnedTopData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}

function getPinnedBottomData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}
function onBtStopEditing() {
  gridApi!.stopEditing();
}

function onBtStartEditing(key?: string, pinned?: RowPinnedType) {
  gridApi!.setFocusedCell(0, "lastName", pinned);

  gridApi!.startEditingCell({
    rowIndex: 0,
    colKey: "lastName",
    // set to 'top', 'bottom' or undefined
    rowPinned: pinned,
    key: key,
  });
}

function onBtNextCell() {
  gridApi!.tabToNextCell();
}

function onBtPreviousCell() {
  gridApi!.tabToPreviousCell();
}

function onBtWhich() {
  const cellDefs = gridApi!.getEditingCells();
  if (cellDefs.length > 0) {
    const cellDef = cellDefs[0];
    console.log(
      "editing cell is: row = " +
        cellDef.rowIndex +
        ", col = " +
        cellDef.column.getId() +
        ", floating = " +
        cellDef.rowPinned,
    );
  } else {
    console.log("no cells are editing");
  }
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtStopEditing = onBtStopEditing;
  (<any>window).onBtStartEditing = onBtStartEditing;
  (<any>window).onBtNextCell = onBtNextCell;
  (<any>window).onBtPreviousCell = onBtPreviousCell;
  (<any>window).onBtWhich = onBtWhich;
}
```

[Live example: Cell Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/cell-editing/typescript/)

## Enter Key Navigation

By default pressing `↵ Enter` will start editing on a cell, or stop editing on an editing cell. It will not navigate to the cell below.

To allow consistency with Excel the grid has the following properties:

- `enterNavigatesVertically`: Set to `true` to have `↵ Enter` key move focus to the cell below if not editing. The default is `↵ Enter` key starts editing the currently focused cell.
- `enterNavigatesVerticallyAfterEdit`: Set to `true` to have `↵ Enter` key move focus to the cell below after `↵ Enter` is pressed while editing. The default is editing will stop and focus will remain on the editing cell.

The example below demonstrates the focus moving down when `↵ Enter` is pressed.

#### Enter Key Navigation

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    editable: true,
  },
  enterNavigatesVertically: true,
  enterNavigatesVerticallyAfterEdit: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Enter Key Navigation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/enter-key-navigation/typescript/)

## Single-Click Editing

The default is for the grid to enter editing when you Double-Click on a cell. To change the default so that a single-click starts editing, set the property `gridOptions.singleClickEdit = true`. This is useful when you want a cell to enter edit mode as soon as you click on it, similar to the experience you get when inside Excel.

It is also possible to define single-click editing on a per-column basis using `colDef.singleClickEdit = true`.

The grid below has `singleClickEdit = true` so that editing will start on a cell when you single-click on it.

#### Single Click Editing

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    editable: true,
  },
  // set the top grid to single click editing
  singleClickEdit: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Single Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing/typescript/)

## No-Click Editing

It is possible to configure the grid so neither Single-Click or Double-Click starts editing. To do this set the property `suppressClickEdit=true`. This is useful when you want to start the editing in another way, such as including a button in your cell renderer.

The grid below has `suppressClickEdit = true` so that clicking doesn't started editing. The grid configures a Cell Renderer with a button to start editing.

#### No Click Editing

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CellRenderer } from "./cellRenderer";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 180 },
    { field: "age" },
    { field: "country", minWidth: 160 },
    { field: "year" },
    { field: "date", minWidth: 160 },
    { field: "sport", minWidth: 180 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    editable: true,
    // we use a cell renderer to include a button, so when the button
    // gets clicked, the editing starts.
    cellRenderer: CellRenderer,
  },
  // set the bottom grid to no click editing
  suppressClickEdit: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: No Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing-renderer/typescript/)

## Stop Editing When Grid Loses Focus

By default, the grid will not stop editing the currently editing cell when the cell loses focus, unless another cell is clicked on. This means clicking on the grid header, or another part of your application, will not stop editing. This can be bad if, for example, you have a save button, and you need the grid to stop editing before you execute your save function (e.g. you want to make sure the edit is saved into the grid's state).

If you want the grid to stop editing when focus leaves the cell or the grid, set the grid property `stopEditingWhenCellsLoseFocus = true`.

The example below shows the editing with `stopEditingWhenCellsLoseFocus = true`. Notice the following:

- Double-click to start editing 'Age', then click outside the grid (on the 'Dummy Save' button, or the dummy text field) and the grid will stop editing.
- Double-click to start editing 'Year', a custom popup editor appears, you can click anywhere on the popup editor, but once you click outside the editor, the popup closes.

#### Stop Editing When Grid Loses Focus

```ts
import {
  ClientSideRowModelModule,
  CustomEditorModule,
  GridApi,
  GridOptions,
  ICellEditorComp,
  ICellEditorParams,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  CustomEditorModule,
  ClientSideRowModelModule,
]);

class YearCellEditor implements ICellEditorComp {
  eGui: any;
  value: any;

  getGui() {
    return this.eGui;
  }

  getValue() {
    return this.value;
  }

  isPopup() {
    return true;
  }

  init(params: ICellEditorParams) {
    this.value = params.value;
    const tempElement = document.createElement("div");
    tempElement.innerHTML =
      '<div class="yearSelect">' +
      "<div>Clicking here does not close the popup!</div>" +
      '<button id="bt2006" class="yearButton">2006</button>' +
      '<button id="bt2008" class="yearButton">2008</button>' +
      '<button id="bt2010" class="yearButton">2010</button>' +
      '<button id="bt2012" class="yearButton">2012</button>' +
      "<div>" +
      '<input type="text" style="width: 100%;" placeholder="clicking on this text field does not close"/>' +
      "</div>" +
      "</div>";

    [2006, 2008, 2010, 2012].forEach((year) => {
      tempElement.querySelector("#bt" + year)!.addEventListener("click", () => {
        this.value = year;
        params.stopEditing();
      });
    });

    this.eGui = tempElement.firstChild;
  }
}

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year", cellEditor: YearCellEditor, cellEditorPopup: true },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: true,
    editable: true,
  },
  // this property tells grid to stop editing if the
  // grid loses focus
  stopEditingWhenCellsLoseFocus: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Stop Editing When Grid Loses Focus](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/stop-edit-when-grid-loses-focus/typescript/)

> **Note**
>
> Cell Editing can also be performed via Cell Editor Components; please see [Cell Editor Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editors/) for more information.


---
product: "AG Grid"
title: "Start/Stop Cell Editing"
description: "This page discusses the different ways in which Cell Editing can be started and stopped."
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-full-row/"
    - title: "Validation"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-validation/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Start/Stop Cell Editing

This page discusses the different ways in which Cell Editing can be started and stopped.

## Start Editing

Assuming `editable=true` or `editable` has a callback that returns `true` for the Column Definition, editing will start upon any of the following:

- **Edit Key Pressed**: One of the following is pressed: `↵ Enter`, `F2`.
- **Backspace**: The default editor will start and clear the contents of the cell if `Backspace` is pressed on Windows. To mimic this behaviour on MacOS, use the `enableCellEditingOnBackspace=true` grid option.
- **Printable Key Pressed**: Any of the following characters are pressed: `abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!"£$%^&amp;*()_+-=[];\'#,./\|<>?:@~{}`
   The default editor places this character into the edit field so that the user experience is they are typing into the cell.
- **Mouse Double Click**: If the mouse is double-clicked. There is a grid property `singleClickEdit` that will allow single-click to start editing instead of double-click. Another property `suppressClickEdit` will prevent both single-click and double-click from starting the edit; use this if you only want to have your own way of starting editing, such as clicking a button in your custom cell renderer.
- **api.startEditingCell(params)**: If you call `startEditingCell(params)` on the grid API

## Stop Editing

The grid will stop editing when any of the following happen:

- **Callback stopEditing**: The callback `stopEditing` (from the params above) gets called by the editor. This is how your cell editor informs the grid to stop editing.
- **Other Cell Focus**: If focus in the grid goes to another cell, the editing will stop.
- **Enter Key Down**: If the grid receives an `↵ Enter` key press event on the cell. If you do **not** want to stop editing when `↵ Enter` is pressed, then listen for the event and stop propagation so the grid does not act on the event.
- **Escape Key Down**: Similar to `↵ Enter`, if `⎋ Esc` key is pressed, editing will stop. Unlike `↵ Enter`, the `⎋ Esc` action will discard changes rather than taking the new value.
- **Tab Key Down**: Editing will stop, accepting changes, and editing will move to the next cell, or the previous cell if `⇧ Shift` is also pressed.
- **Popup Editor Closed**: If using popup editor, the popup is configured to close if you click outside the editor. Closing the popup triggers the grid to stop editing.
- **gridApi.stopEditing()**: If you call `stopEditing()` on the grid API.

### Start / Stop Events

The following events are fired when editing is started and stopped.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditingStarted` | `CellEditingStartedEvent` |  |  |  |
| `cellEditingStopped` | `CellEditingStoppedEvent` |  |  |  |

## Tab Navigation

While editing, if you hit `⇥ Tab`, the editing will stop for the current cell and start on the next cell. If you hold down `⇧ Shift`+`⇥ Tab`, the same will happen except the previous cell will start editing rather than the next. This is in line with editing data in Excel.

The next and previous cells can also be navigated using the API functions `api.tabToNextCell()` and `api.tabToPreviousCell()`. Both of these methods will return `true` if the navigation was successful, otherwise `false`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `tabToNextCell` | `Function` |  |  |  |
| `tabToPreviousCell` | `Function` |  |  |  |

## Editing API

The grid has the following API methods for editing:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `startEditingCell` | `Function` |  |  |  |
| `stopEditing` | `Function` |  |  |  |
| `isEditing` | `Function` |  |  |  |
| `getEditingCells` | `Function` |  |  |  |
| `getEditRowValues` | `Function` |  |  |  |

If the grid is editing, `getEditingCells()` returns back details of the editing cell(s). The result is an array of objects. If only one cell is editing (the default) then the array will have one entry. If multiple cells are editing (e.g. [Full Row Edit](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-full-row/)) then the array contains all editing cells.

Below is a code example of using the editing API methods.

```ts
// start editing country cell on first row
this.gridApi.startEditingCell({
    rowIndex: 0,
    colKey: 'country'
});

// stop editing
this.gridApi.stopEditing();

// print details of editing cell
const cellDefs = this.gridApi.getEditingCells();
cellDefs.forEach(cellDef => {
    console.log(cellDef.rowIndex);
    console.log(cellDef.column.getId());
    console.log(cellDef.rowPinned);
});
```

The example below illustrates different parts of the editing API. Each button starts editing the 'Last Name' column of the first row with the following differences:

- `edit()`: Normal editing start.
- `edit(Backspace)`: Edit as if delete button was pressed (clears contents first).
- `edit('T')`: Edit as if 'T' was pressed (places 'T' into cell).
- `edit(top)`: Edits top pinned row.
- `edit(bottom)`: Edits bottom pinned row.

The example also demonstrates the following buttons for edit navigation:

- `stop()`: Stops editing.
- `next()`: Edits the next cell.
- `previous()`: Edits the previous cell.

Finally, the example also demonstrates querying which cell is editing:

- `which()`: If the grid is editing, prints to the console which cell is in edit mode.

Events are logged in the developer console.

#### Cell Editing

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  CellEditingStartedEvent,
  CellEditingStoppedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  PinnedRowModule,
  RowEditingStartedEvent,
  RowEditingStoppedEvent,
  RowPinnedType,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  PinnedRowModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div>
      <div style="margin-bottom: 5px; display: flex">
        <button (click)="onBtStartEditing(undefined)">edit (0)</button>
        <button (click)="onBtStartEditing('Backspace')">
          edit (0, Backspace)
        </button>
        <button (click)="onBtStartEditing('T')">edit (0, 'T')</button>
        <button (click)="onBtStartEditing(undefined, 'top')">
          edit (0, Top)
        </button>
        <button (click)="onBtStartEditing(undefined, 'bottom')">
          edit (0, Bottom)
        </button>
      </div>
      <div style="margin-bottom: 5px; display: flex">
        <button (click)="onBtStopEditing()">stop ()</button>
        <button (click)="onBtNextCell()">next ()</button>
        <button (click)="onBtPreviousCell()">previous ()</button>
        <button (click)="onBtWhich()">which ()</button>
      </div>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [defaultColDef]="defaultColDef"
        [rowData]="rowData"
        [pinnedTopRowData]="pinnedTopRowData"
        [pinnedBottomRowData]="pinnedBottomRowData"
        (rowEditingStarted)="onRowEditingStarted($event)"
        (rowEditingStopped)="onRowEditingStopped($event)"
        (cellEditingStarted)="onCellEditingStarted($event)"
        (cellEditingStopped)="onCellEditingStopped($event)"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "firstName" },
    { field: "lastName" },
    { field: "gender" },
    { field: "age" },
    { field: "mood" },
    { field: "country" },
    { field: "address", minWidth: 550 },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 110,
    editable: true,
  };
  rowData: any[] | null = getData();
  pinnedTopRowData: any[] = getPinnedTopData();
  pinnedBottomRowData: any[] = getPinnedBottomData();

  onRowEditingStarted(event: RowEditingStartedEvent) {
    console.log("never called - not doing row editing");
  }

  onRowEditingStopped(event: RowEditingStoppedEvent) {
    console.log("never called - not doing row editing");
  }

  onCellEditingStarted(event: CellEditingStartedEvent) {
    console.log("cellEditingStarted");
  }

  onCellEditingStopped(event: CellEditingStoppedEvent) {
    console.log("cellEditingStopped");
  }

  onBtStopEditing() {
    this.gridApi.stopEditing();
  }

  onBtStartEditing(key?: string, pinned?: RowPinnedType) {
    this.gridApi.setFocusedCell(0, "lastName", pinned);
    this.gridApi.startEditingCell({
      rowIndex: 0,
      colKey: "lastName",
      // set to 'top', 'bottom' or undefined
      rowPinned: pinned,
      key: key,
    });
  }

  onBtNextCell() {
    this.gridApi.tabToNextCell();
  }

  onBtPreviousCell() {
    this.gridApi.tabToPreviousCell();
  }

  onBtWhich() {
    const cellDefs = this.gridApi.getEditingCells();
    if (cellDefs.length > 0) {
      const cellDef = cellDefs[0];
      console.log(
        "editing cell is: row = " +
          cellDef.rowIndex +
          ", col = " +
          cellDef.column.getId() +
          ", floating = " +
          cellDef.rowPinned,
      );
    } else {
      console.log("no cells are editing");
    }
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

function getPinnedTopData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}
function getPinnedBottomData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}
```

[Live example: Cell Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/cell-editing/angular/)

## Enter Key Navigation

By default pressing `↵ Enter` will start editing on a cell, or stop editing on an editing cell. It will not navigate to the cell below.

To allow consistency with Excel the grid has the following properties:

- `enterNavigatesVertically`: Set to `true` to have `↵ Enter` key move focus to the cell below if not editing. The default is `↵ Enter` key starts editing the currently focused cell.
- `enterNavigatesVerticallyAfterEdit`: Set to `true` to have `↵ Enter` key move focus to the cell below after `↵ Enter` is pressed while editing. The default is editing will stop and focus will remain on the editing cell.

The example below demonstrates the focus moving down when `↵ Enter` is pressed.

#### Enter Key Navigation

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [enterNavigatesVertically]="true"
    [enterNavigatesVerticallyAfterEdit]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    editable: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Enter Key Navigation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/enter-key-navigation/angular/)

## Single-Click Editing

The default is for the grid to enter editing when you Double-Click on a cell. To change the default so that a single-click starts editing, set the property `gridOptions.singleClickEdit = true`. This is useful when you want a cell to enter edit mode as soon as you click on it, similar to the experience you get when inside Excel.

It is also possible to define single-click editing on a per-column basis using `colDef.singleClickEdit = true`.

The grid below has `singleClickEdit = true` so that editing will start on a cell when you single-click on it.

#### Single Click Editing

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [singleClickEdit]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    editable: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Single Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing/angular/)

## No-Click Editing

It is possible to configure the grid so neither Single-Click or Double-Click starts editing. To do this set the property `suppressClickEdit=true`. This is useful when you want to start the editing in another way, such as including a button in your cell renderer.

The grid below has `suppressClickEdit = true` so that clicking doesn't started editing. The grid configures a Cell Renderer with a button to start editing.

#### No Click Editing

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);
import { CellRenderer } from "./cell-renderer.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CellRenderer],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [suppressClickEdit]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 180 },
    { field: "age" },
    { field: "country", minWidth: 160 },
    { field: "year" },
    { field: "date", minWidth: 160 },
    { field: "sport", minWidth: 180 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    editable: true,
    // we use a cell renderer to include a button, so when the button
    // gets clicked, the editing starts.
    cellRenderer: CellRenderer,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: No Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing-renderer/angular/)

## Stop Editing When Grid Loses Focus

By default, the grid will not stop editing the currently editing cell when the cell loses focus, unless another cell is clicked on. This means clicking on the grid header, or another part of your application, will not stop editing. This can be bad if, for example, you have a save button, and you need the grid to stop editing before you execute your save function (e.g. you want to make sure the edit is saved into the grid's state).

If you want the grid to stop editing when focus leaves the cell or the grid, set the grid property `stopEditingWhenCellsLoseFocus = true`.

The example below shows the editing with `stopEditingWhenCellsLoseFocus = true`. Notice the following:

- Double-click to start editing 'Age', then click outside the grid (on the 'Dummy Save' button, or the dummy text field) and the grid will stop editing.
- Double-click to start editing 'Year', a custom popup editor appears, you can click anywhere on the popup editor, but once you click outside the editor, the popup closes.

#### Stop Editing When Grid Loses Focus

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CustomEditorModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ICellEditorComp,
  ICellEditorParams,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  CustomEditorModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      Clicking outside the grid will stop the editing
      <button style="font-size: 12px">Dummy Save</button>
      <input placeholder="click here, editing stops" />
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [stopEditingWhenCellsLoseFocus]="true"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year", cellEditor: YearCellEditor, cellEditorPopup: true },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: true,
    editable: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

class YearCellEditor implements ICellEditorComp {
  eGui: any;
  value: any;

  getGui() {
    return this.eGui;
  }

  getValue() {
    return this.value;
  }

  isPopup() {
    return true;
  }

  init(params: ICellEditorParams) {
    this.value = params.value;
    const tempElement = document.createElement("div");
    tempElement.innerHTML =
      '<div class="yearSelect">' +
      "<div>Clicking here does not close the popup!</div>" +
      '<button id="bt2006" class="yearButton">2006</button>' +
      '<button id="bt2008" class="yearButton">2008</button>' +
      '<button id="bt2010" class="yearButton">2010</button>' +
      '<button id="bt2012" class="yearButton">2012</button>' +
      "<div>" +
      '<input type="text" style="width: 100%;" placeholder="clicking on this text field does not close"/>' +
      "</div>" +
      "</div>";

    [2006, 2008, 2010, 2012].forEach((year) => {
      tempElement.querySelector("#bt" + year)!.addEventListener("click", () => {
        this.value = year;
        params.stopEditing();
      });
    });

    this.eGui = tempElement.firstChild;
  }
}
```

[Live example: Stop Editing When Grid Loses Focus](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/stop-edit-when-grid-loses-focus/angular/)

> **Note**
>
> Cell Editing can also be performed via Cell Editor Components; please see [Cell Editor Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editors/) for more information.


---
product: "AG Grid"
title: "Start/Stop Cell Editing"
description: "This page discusses the different ways in which Cell Editing can be started and stopped."
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-full-row/"
    - title: "Validation"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-validation/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Start/Stop Cell Editing

This page discusses the different ways in which Cell Editing can be started and stopped.

## Start Editing

Assuming `editable=true` or `editable` has a callback that returns `true` for the Column Definition, editing will start upon any of the following:

- **Edit Key Pressed**: One of the following is pressed: `↵ Enter`, `F2`.
- **Backspace**: The default editor will start and clear the contents of the cell if `Backspace` is pressed on Windows. To mimic this behaviour on MacOS, use the `enableCellEditingOnBackspace=true` grid option.
- **Printable Key Pressed**: Any of the following characters are pressed: `abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!"£$%^&amp;*()_+-=[];\'#,./\|<>?:@~{}`
   The default editor places this character into the edit field so that the user experience is they are typing into the cell.
- **Mouse Double Click**: If the mouse is double-clicked. There is a grid property `singleClickEdit` that will allow single-click to start editing instead of double-click. Another property `suppressClickEdit` will prevent both single-click and double-click from starting the edit; use this if you only want to have your own way of starting editing, such as clicking a button in your custom cell renderer.
- **api.startEditingCell(params)**: If you call `startEditingCell(params)` on the grid API

## Stop Editing

The grid will stop editing when any of the following happen:

- **Callback stopEditing**: The callback `stopEditing` (from the params above) gets called by the editor. This is how your cell editor informs the grid to stop editing.
- **Other Cell Focus**: If focus in the grid goes to another cell, the editing will stop.
- **Enter Key Down**: If the grid receives an `↵ Enter` key press event on the cell. If you do **not** want to stop editing when `↵ Enter` is pressed, then listen for the event and stop propagation so the grid does not act on the event.
- **Escape Key Down**: Similar to `↵ Enter`, if `⎋ Esc` key is pressed, editing will stop. Unlike `↵ Enter`, the `⎋ Esc` action will discard changes rather than taking the new value.
- **Tab Key Down**: Editing will stop, accepting changes, and editing will move to the next cell, or the previous cell if `⇧ Shift` is also pressed.
- **Popup Editor Closed**: If using popup editor, the popup is configured to close if you click outside the editor. Closing the popup triggers the grid to stop editing.
- **gridApi.stopEditing()**: If you call `stopEditing()` on the grid API.

### Start / Stop Events

The following events are fired when editing is started and stopped.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditingStarted` | `CellEditingStartedEvent` |  |  |  |
| `cellEditingStopped` | `CellEditingStoppedEvent` |  |  |  |

## Tab Navigation

While editing, if you hit `⇥ Tab`, the editing will stop for the current cell and start on the next cell. If you hold down `⇧ Shift`+`⇥ Tab`, the same will happen except the previous cell will start editing rather than the next. This is in line with editing data in Excel.

The next and previous cells can also be navigated using the API functions `api.tabToNextCell()` and `api.tabToPreviousCell()`. Both of these methods will return `true` if the navigation was successful, otherwise `false`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `tabToNextCell` | `Function` |  |  |  |
| `tabToPreviousCell` | `Function` |  |  |  |

## Editing API

The grid has the following API methods for editing:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `startEditingCell` | `Function` |  |  |  |
| `stopEditing` | `Function` |  |  |  |
| `isEditing` | `Function` |  |  |  |
| `getEditingCells` | `Function` |  |  |  |
| `getEditRowValues` | `Function` |  |  |  |

If the grid is editing, `getEditingCells()` returns back details of the editing cell(s). The result is an array of objects. If only one cell is editing (the default) then the array will have one entry. If multiple cells are editing (e.g. [Full Row Edit](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-full-row/)) then the array contains all editing cells.

Below is a code example of using the editing API methods.

```jsx
// start editing country cell on first row
gridApi.startEditingCell({
    rowIndex: 0,
    colKey: 'country'
});

// stop editing
gridApi.stopEditing();

// print details of editing cell
const cellDefs = gridApi.getEditingCells();
cellDefs.forEach(cellDef => {
    console.log(cellDef.rowIndex);
    console.log(cellDef.column.getId());
    console.log(cellDef.rowPinned);
});
```

The example below illustrates different parts of the editing API. Each button starts editing the 'Last Name' column of the first row with the following differences:

- `edit()`: Normal editing start.
- `edit(Backspace)`: Edit as if delete button was pressed (clears contents first).
- `edit('T')`: Edit as if 'T' was pressed (places 'T' into cell).
- `edit(top)`: Edits top pinned row.
- `edit(bottom)`: Edits bottom pinned row.

The example also demonstrates the following buttons for edit navigation:

- `stop()`: Stops editing.
- `next()`: Edits the next cell.
- `previous()`: Edits the previous cell.

Finally, the example also demonstrates querying which cell is editing:

- `which()`: If the grid is editing, prints to the console which cell is in edit mode.

Events are logged in the developer console.

#### Cell Editing

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  CellEditingStartedEvent,
  CellEditingStoppedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  PinnedRowModule,
  RowEditingStartedEvent,
  RowEditingStoppedEvent,
  RowPinnedType,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  PinnedRowModule,
  ClientSideRowModelModule,
];

function getPinnedTopData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}

function getPinnedBottomData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "firstName" },
    { field: "lastName" },
    { field: "gender" },
    { field: "age" },
    { field: "mood" },
    { field: "country" },
    { field: "address", minWidth: 550 },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 110,
      editable: true,
    };
  }, []);
  const pinnedTopRowData = useMemo<any[]>(() => {
    return getPinnedTopData();
  }, []);
  const pinnedBottomRowData = useMemo<any[]>(() => {
    return getPinnedBottomData();
  }, []);

  const onRowEditingStarted = useCallback((event: RowEditingStartedEvent) => {
    console.log("never called - not doing row editing");
  }, []);

  const onRowEditingStopped = useCallback((event: RowEditingStoppedEvent) => {
    console.log("never called - not doing row editing");
  }, []);

  const onCellEditingStarted = useCallback((event: CellEditingStartedEvent) => {
    console.log("cellEditingStarted");
  }, []);

  const onCellEditingStopped = useCallback((event: CellEditingStoppedEvent) => {
    console.log("cellEditingStopped");
  }, []);

  const onBtStopEditing = useCallback(() => {
    gridRef.current!.api.stopEditing();
  }, []);

  const onBtStartEditing = useCallback(
    (key?: string, pinned?: RowPinnedType) => {
      gridRef.current!.api.setFocusedCell(0, "lastName", pinned);
      gridRef.current!.api.startEditingCell({
        rowIndex: 0,
        colKey: "lastName",
        // set to 'top', 'bottom' or undefined
        rowPinned: pinned,
        key: key,
      });
    },
    [],
  );

  const onBtNextCell = useCallback(() => {
    gridRef.current!.api.tabToNextCell();
  }, []);

  const onBtPreviousCell = useCallback(() => {
    gridRef.current!.api.tabToPreviousCell();
  }, []);

  const onBtWhich = useCallback(() => {
    const cellDefs = gridRef.current!.api.getEditingCells();
    if (cellDefs.length > 0) {
      const cellDef = cellDefs[0];
      console.log(
        "editing cell is: row = " +
          cellDef.rowIndex +
          ", col = " +
          cellDef.column.getId() +
          ", floating = " +
          cellDef.rowPinned,
      );
    } else {
      console.log("no cells are editing");
    }
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div>
            <div style={{ marginBottom: "5px", display: "flex" }}>
              <button onClick={() => onBtStartEditing(undefined)}>
                edit (0)
              </button>
              <button onClick={() => onBtStartEditing("Backspace")}>
                edit (0, Backspace)
              </button>
              <button onClick={() => onBtStartEditing("T")}>
                edit (0, 'T')
              </button>
              <button onClick={() => onBtStartEditing(undefined, "top")}>
                edit (0, Top)
              </button>
              <button onClick={() => onBtStartEditing(undefined, "bottom")}>
                edit (0, Bottom)
              </button>
            </div>
            <div style={{ marginBottom: "5px", display: "flex" }}>
              <button onClick={onBtStopEditing}>stop ()</button>
              <button onClick={onBtNextCell}>next ()</button>
              <button onClick={onBtPreviousCell}>previous ()</button>
              <button onClick={onBtWhich}>which ()</button>
            </div>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact
                ref={gridRef}
                rowData={rowData}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                pinnedTopRowData={pinnedTopRowData}
                pinnedBottomRowData={pinnedBottomRowData}
                onRowEditingStarted={onRowEditingStarted}
                onRowEditingStopped={onRowEditingStopped}
                onCellEditingStarted={onCellEditingStarted}
                onCellEditingStopped={onCellEditingStopped}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/cell-editing/reactFunctionalTs/)

## Enter Key Navigation

By default pressing `↵ Enter` will start editing on a cell, or stop editing on an editing cell. It will not navigate to the cell below.

To allow consistency with Excel the grid has the following properties:

- `enterNavigatesVertically`: Set to `true` to have `↵ Enter` key move focus to the cell below if not editing. The default is `↵ Enter` key starts editing the currently focused cell.
- `enterNavigatesVerticallyAfterEdit`: Set to `true` to have `↵ Enter` key move focus to the cell below after `↵ Enter` is pressed while editing. The default is editing will stop and focus will remain on the editing cell.

The example below demonstrates the focus moving down when `↵ Enter` is pressed.

#### Enter Key Navigation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      editable: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            enterNavigatesVertically={true}
            enterNavigatesVerticallyAfterEdit={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Enter Key Navigation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/enter-key-navigation/reactFunctionalTs/)

## Single-Click Editing

The default is for the grid to enter editing when you Double-Click on a cell. To change the default so that a single-click starts editing, set the property `gridOptions.singleClickEdit = true`. This is useful when you want a cell to enter edit mode as soon as you click on it, similar to the experience you get when inside Excel.

It is also possible to define single-click editing on a per-column basis using `colDef.singleClickEdit = true`.

The grid below has `singleClickEdit = true` so that editing will start on a cell when you single-click on it.

#### Single Click Editing

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      editable: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            singleClickEdit={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Single Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing/reactFunctionalTs/)

## No-Click Editing

It is possible to configure the grid so neither Single-Click or Double-Click starts editing. To do this set the property `suppressClickEdit=true`. This is useful when you want to start the editing in another way, such as including a button in your cell renderer.

The grid below has `suppressClickEdit = true` so that clicking doesn't started editing. The grid configures a Cell Renderer with a button to start editing.

#### No Click Editing

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import CellRenderer from "./cellRenderer.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 180 },
    { field: "age" },
    { field: "country", minWidth: 160 },
    { field: "year" },
    { field: "date", minWidth: 160 },
    { field: "sport", minWidth: 180 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      editable: true,
      // we use a cell renderer to include a button, so when the button
      // gets clicked, the editing starts.
      cellRenderer: CellRenderer,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            suppressClickEdit={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: No Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing-renderer/reactFunctionalTs/)

## Stop Editing When Grid Loses Focus

By default, the grid will not stop editing the currently editing cell when the cell loses focus, unless another cell is clicked on. This means clicking on the grid header, or another part of your application, will not stop editing. This can be bad if, for example, you have a save button, and you need the grid to stop editing before you execute your save function (e.g. you want to make sure the edit is saved into the grid's state).

If you want the grid to stop editing when focus leaves the cell or the grid, set the grid property `stopEditingWhenCellsLoseFocus = true`.

The example below shows the editing with `stopEditingWhenCellsLoseFocus = true`. Notice the following:

- Double-click to start editing 'Age', then click outside the grid (on the 'Dummy Save' button, or the dummy text field) and the grid will stop editing.
- Double-click to start editing 'Year', a custom popup editor appears, you can click anywhere on the popup editor, but once you click outside the editor, the popup closes.

#### Stop Editing When Grid Loses Focus

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CustomEditorModule,
  GridApi,
  GridOptions,
  ICellEditorComp,
  ICellEditorParams,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  CustomEditorModule,
  ClientSideRowModelModule,
];

class YearCellEditor implements ICellEditorComp {
  eGui: any;
  value: any;

  getGui() {
    return this.eGui;
  }

  getValue() {
    return this.value;
  }

  isPopup() {
    return true;
  }

  init(params: ICellEditorParams) {
    this.value = params.value;
    const tempElement = document.createElement("div");
    tempElement.innerHTML =
      '<div class="yearSelect">' +
      "<div>Clicking here does not close the popup!</div>" +
      '<button id="bt2006" class="yearButton">2006</button>' +
      '<button id="bt2008" class="yearButton">2008</button>' +
      '<button id="bt2010" class="yearButton">2010</button>' +
      '<button id="bt2012" class="yearButton">2012</button>' +
      "<div>" +
      '<input type="text" style="width: 100%;" placeholder="clicking on this text field does not close"/>' +
      "</div>" +
      "</div>";

    [2006, 2008, 2010, 2012].forEach((year) => {
      tempElement.querySelector("#bt" + year)!.addEventListener("click", () => {
        this.value = year;
        params.stopEditing();
      });
    });

    this.eGui = tempElement.firstChild;
  }
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year", cellEditor: YearCellEditor, cellEditorPopup: true },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      filter: true,
      editable: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            Clicking outside the grid will stop the editing{" "}
            <button style={{ fontSize: "12px" }}>Dummy Save</button>
            <input placeholder="click here, editing stops" />
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              stopEditingWhenCellsLoseFocus={true}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Stop Editing When Grid Loses Focus](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/stop-edit-when-grid-loses-focus/reactFunctionalTs/)

> **Note**
>
> Cell Editing can also be performed via Cell Editor Components; please see [Cell Editor Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editors/) for more information.


---
product: "AG Grid"
title: "Start/Stop Cell Editing"
description: "This page discusses the different ways in which Cell Editing can be started and stopped."
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing/"
    - title: "Parsing Values"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-parsers/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-full-row/"
    - title: "Validation"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-validation/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Start/Stop Cell Editing

This page discusses the different ways in which Cell Editing can be started and stopped.

## Start Editing

Assuming `editable=true` or `editable` has a callback that returns `true` for the Column Definition, editing will start upon any of the following:

- **Edit Key Pressed**: One of the following is pressed: `↵ Enter`, `F2`.
- **Backspace**: The default editor will start and clear the contents of the cell if `Backspace` is pressed on Windows. To mimic this behaviour on MacOS, use the `enableCellEditingOnBackspace=true` grid option.
- **Printable Key Pressed**: Any of the following characters are pressed: `abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!"£$%^&amp;*()_+-=[];\'#,./\|<>?:@~{}`
   The default editor places this character into the edit field so that the user experience is they are typing into the cell.
- **Mouse Double Click**: If the mouse is double-clicked. There is a grid property `singleClickEdit` that will allow single-click to start editing instead of double-click. Another property `suppressClickEdit` will prevent both single-click and double-click from starting the edit; use this if you only want to have your own way of starting editing, such as clicking a button in your custom cell renderer.
- **api.startEditingCell(params)**: If you call `startEditingCell(params)` on the grid API

## Stop Editing

The grid will stop editing when any of the following happen:

- **Callback stopEditing**: The callback `stopEditing` (from the params above) gets called by the editor. This is how your cell editor informs the grid to stop editing.
- **Other Cell Focus**: If focus in the grid goes to another cell, the editing will stop.
- **Enter Key Down**: If the grid receives an `↵ Enter` key press event on the cell. If you do **not** want to stop editing when `↵ Enter` is pressed, then listen for the event and stop propagation so the grid does not act on the event.
- **Escape Key Down**: Similar to `↵ Enter`, if `⎋ Esc` key is pressed, editing will stop. Unlike `↵ Enter`, the `⎋ Esc` action will discard changes rather than taking the new value.
- **Tab Key Down**: Editing will stop, accepting changes, and editing will move to the next cell, or the previous cell if `⇧ Shift` is also pressed.
- **Popup Editor Closed**: If using popup editor, the popup is configured to close if you click outside the editor. Closing the popup triggers the grid to stop editing.
- **gridApi.stopEditing()**: If you call `stopEditing()` on the grid API.

### Start / Stop Events

The following events are fired when editing is started and stopped.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditingStarted` | `CellEditingStartedEvent` |  |  |  |
| `cellEditingStopped` | `CellEditingStoppedEvent` |  |  |  |

## Tab Navigation

While editing, if you hit `⇥ Tab`, the editing will stop for the current cell and start on the next cell. If you hold down `⇧ Shift`+`⇥ Tab`, the same will happen except the previous cell will start editing rather than the next. This is in line with editing data in Excel.

The next and previous cells can also be navigated using the API functions `api.tabToNextCell()` and `api.tabToPreviousCell()`. Both of these methods will return `true` if the navigation was successful, otherwise `false`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `tabToNextCell` | `Function` |  |  |  |
| `tabToPreviousCell` | `Function` |  |  |  |

## Editing API

The grid has the following API methods for editing:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `startEditingCell` | `Function` |  |  |  |
| `stopEditing` | `Function` |  |  |  |
| `isEditing` | `Function` |  |  |  |
| `getEditingCells` | `Function` |  |  |  |
| `getEditRowValues` | `Function` |  |  |  |

If the grid is editing, `getEditingCells()` returns back details of the editing cell(s). The result is an array of objects. If only one cell is editing (the default) then the array will have one entry. If multiple cells are editing (e.g. [Full Row Edit](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-full-row/)) then the array contains all editing cells.

Below is a code example of using the editing API methods.

```ts
// start editing country cell on first row
this.gridApi.startEditingCell({
    rowIndex: 0,
    colKey: 'country'
});

// stop editing
this.gridApi.stopEditing();

// print details of editing cell
const cellDefs = this.gridApi.getEditingCells();
cellDefs.forEach(cellDef => {
    console.log(cellDef.rowIndex);
    console.log(cellDef.column.getId());
    console.log(cellDef.rowPinned);
});
```

The example below illustrates different parts of the editing API. Each button starts editing the 'Last Name' column of the first row with the following differences:

- `edit()`: Normal editing start.
- `edit(Backspace)`: Edit as if delete button was pressed (clears contents first).
- `edit('T')`: Edit as if 'T' was pressed (places 'T' into cell).
- `edit(top)`: Edits top pinned row.
- `edit(bottom)`: Edits bottom pinned row.

The example also demonstrates the following buttons for edit navigation:

- `stop()`: Stops editing.
- `next()`: Edits the next cell.
- `previous()`: Edits the previous cell.

Finally, the example also demonstrates querying which cell is editing:

- `which()`: If the grid is editing, prints to the console which cell is in edit mode.

Events are logged in the developer console.

#### Cell Editing

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  CellEditingStartedEvent,
  CellEditingStoppedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  PinnedRowModule,
  RowEditingStartedEvent,
  RowEditingStoppedEvent,
  RowPinnedType,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  PinnedRowModule,
  ClientSideRowModelModule,
]);

function getPinnedTopData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}

function getPinnedBottomData() {
  return [
    {
      firstName: "##",
      lastName: "##",
      gender: "##",
      address: "##",
      mood: "##",
      country: "##",
    },
  ];
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div>
        <div style="margin-bottom: 5px; display: flex">
          <button v-on:click="onBtStartEditing(undefined)">edit (0)</button>
          <button v-on:click="onBtStartEditing('Backspace')">edit (0, Backspace)</button>
          <button v-on:click="onBtStartEditing('T')">edit (0, 'T')</button>
          <button v-on:click="onBtStartEditing(undefined, 'top')">edit (0, Top)</button>
          <button v-on:click="onBtStartEditing(undefined, 'bottom')">edit (0, Bottom)</button>
        </div>
        <div style="margin-bottom: 5px; display: flex">
          <button v-on:click="onBtStopEditing()">stop ()</button>
          <button v-on:click="onBtNextCell()">next ()</button>
          <button v-on:click="onBtPreviousCell()">previous ()</button>
          <button v-on:click="onBtWhich()">which ()</button>
        </div>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :rowData="rowData"
          :pinnedTopRowData="pinnedTopRowData"
          :pinnedBottomRowData="pinnedBottomRowData"
          @row-editing-started="onRowEditingStarted"
          @row-editing-stopped="onRowEditingStopped"
          @cell-editing-started="onCellEditingStarted"
          @cell-editing-stopped="onCellEditingStopped"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "firstName" },
      { field: "lastName" },
      { field: "gender" },
      { field: "age" },
      { field: "mood" },
      { field: "country" },
      { field: "address", minWidth: 550 },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 110,
      editable: true,
    });
    const rowData = ref<any[] | null>(getData());
    const pinnedTopRowData = ref<any[]>(getPinnedTopData());
    const pinnedBottomRowData = ref<any[]>(getPinnedBottomData());

    function onRowEditingStarted(event: RowEditingStartedEvent) {
      console.log("never called - not doing row editing");
    }
    function onRowEditingStopped(event: RowEditingStoppedEvent) {
      console.log("never called - not doing row editing");
    }
    function onCellEditingStarted(event: CellEditingStartedEvent) {
      console.log("cellEditingStarted");
    }
    function onCellEditingStopped(event: CellEditingStoppedEvent) {
      console.log("cellEditingStopped");
    }
    function onBtStopEditing() {
      gridApi.value!.stopEditing();
    }
    function onBtStartEditing(key?: string, pinned?: RowPinnedType) {
      gridApi.value!.setFocusedCell(0, "lastName", pinned);
      gridApi.value!.startEditingCell({
        rowIndex: 0,
        colKey: "lastName",
        // set to 'top', 'bottom' or undefined
        rowPinned: pinned,
        key: key,
      });
    }
    function onBtNextCell() {
      gridApi.value!.tabToNextCell();
    }
    function onBtPreviousCell() {
      gridApi.value!.tabToPreviousCell();
    }
    function onBtWhich() {
      const cellDefs = gridApi.value!.getEditingCells();
      if (cellDefs.length > 0) {
        const cellDef = cellDefs[0];
        console.log(
          "editing cell is: row = " +
            cellDef.rowIndex +
            ", col = " +
            cellDef.column.getId() +
            ", floating = " +
            cellDef.rowPinned,
        );
      } else {
        console.log("no cells are editing");
      }
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      pinnedTopRowData,
      pinnedBottomRowData,
      onGridReady,
      onRowEditingStarted,
      onRowEditingStopped,
      onCellEditingStarted,
      onCellEditingStopped,
      onBtStopEditing,
      onBtStartEditing,
      onBtNextCell,
      onBtPreviousCell,
      onBtWhich,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/cell-editing/vue3/)

## Enter Key Navigation

By default pressing `↵ Enter` will start editing on a cell, or stop editing on an editing cell. It will not navigate to the cell below.

To allow consistency with Excel the grid has the following properties:

- `enterNavigatesVertically`: Set to `true` to have `↵ Enter` key move focus to the cell below if not editing. The default is `↵ Enter` key starts editing the currently focused cell.
- `enterNavigatesVerticallyAfterEdit`: Set to `true` to have `↵ Enter` key move focus to the cell below after `↵ Enter` is pressed while editing. The default is editing will stop and focus will remain on the editing cell.

The example below demonstrates the focus moving down when `↵ Enter` is pressed.

#### Enter Key Navigation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :enterNavigatesVertically="true"
      :enterNavigatesVerticallyAfterEdit="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 160 },
      { field: "age" },
      { field: "country", minWidth: 140 },
      { field: "year" },
      { field: "date", minWidth: 140 },
      { field: "sport", minWidth: 160 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      editable: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Enter Key Navigation](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/enter-key-navigation/vue3/)

## Single-Click Editing

The default is for the grid to enter editing when you Double-Click on a cell. To change the default so that a single-click starts editing, set the property `gridOptions.singleClickEdit = true`. This is useful when you want a cell to enter edit mode as soon as you click on it, similar to the experience you get when inside Excel.

It is also possible to define single-click editing on a per-column basis using `colDef.singleClickEdit = true`.

The grid below has `singleClickEdit = true` so that editing will start on a cell when you single-click on it.

#### Single Click Editing

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :singleClickEdit="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 160 },
      { field: "age" },
      { field: "country", minWidth: 140 },
      { field: "year" },
      { field: "date", minWidth: 140 },
      { field: "sport", minWidth: 160 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      editable: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Single Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing/vue3/)

## No-Click Editing

It is possible to configure the grid so neither Single-Click or Double-Click starts editing. To do this set the property `suppressClickEdit=true`. This is useful when you want to start the editing in another way, such as including a button in your cell renderer.

The grid below has `suppressClickEdit = true` so that clicking doesn't started editing. The grid configures a Cell Renderer with a button to start editing.

#### No Click Editing

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import CellRenderer from "./cellRendererVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :suppressClickEdit="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CellRenderer,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 180 },
      { field: "age" },
      { field: "country", minWidth: 160 },
      { field: "year" },
      { field: "date", minWidth: 160 },
      { field: "sport", minWidth: 180 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      editable: true,
      // we use a cell renderer to include a button, so when the button
      // gets clicked, the editing starts.
      cellRenderer: "CellRenderer",
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: No Click Editing](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/single-click-editing-renderer/vue3/)

## Stop Editing When Grid Loses Focus

By default, the grid will not stop editing the currently editing cell when the cell loses focus, unless another cell is clicked on. This means clicking on the grid header, or another part of your application, will not stop editing. This can be bad if, for example, you have a save button, and you need the grid to stop editing before you execute your save function (e.g. you want to make sure the edit is saved into the grid's state).

If you want the grid to stop editing when focus leaves the cell or the grid, set the grid property `stopEditingWhenCellsLoseFocus = true`.

The example below shows the editing with `stopEditingWhenCellsLoseFocus = true`. Notice the following:

- Double-click to start editing 'Age', then click outside the grid (on the 'Dummy Save' button, or the dummy text field) and the grid will stop editing.
- Double-click to start editing 'Year', a custom popup editor appears, you can click anywhere on the popup editor, but once you click outside the editor, the popup closes.

#### Stop Editing When Grid Loses Focus

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CustomEditorModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ICellEditorComp,
  ICellEditorParams,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  CustomEditorModule,
  ClientSideRowModelModule,
]);

class YearCellEditor implements ICellEditorComp {
  eGui: any;
  value: any;

  getGui() {
    return this.eGui;
  }

  getValue() {
    return this.value;
  }

  isPopup() {
    return true;
  }

  init(params: ICellEditorParams) {
    this.value = params.value;
    const tempElement = document.createElement("div");
    tempElement.innerHTML =
      '<div class="yearSelect">' +
      "<div>Clicking here does not close the popup!</div>" +
      '<button id="bt2006" class="yearButton">2006</button>' +
      '<button id="bt2008" class="yearButton">2008</button>' +
      '<button id="bt2010" class="yearButton">2010</button>' +
      '<button id="bt2012" class="yearButton">2012</button>' +
      "<div>" +
      '<input type="text" style="width: 100%;" placeholder="clicking on this text field does not close"/>' +
      "</div>" +
      "</div>";

    [2006, 2008, 2010, 2012].forEach((year) => {
      tempElement.querySelector("#bt" + year)!.addEventListener("click", () => {
        this.value = year;
        params.stopEditing();
      });
    });

    this.eGui = tempElement.firstChild;
  }
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
      Clicking outside the grid will stop the editing <button style="font-size: 12px">Dummy Save</button>
      <input placeholder="click here, editing stops">
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :stopEditingWhenCellsLoseFocus="true"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 160 },
      { field: "age" },
      { field: "country", minWidth: 140 },
      { field: "year", cellEditor: YearCellEditor, cellEditorPopup: true },
      { field: "date", minWidth: 140 },
      { field: "sport", minWidth: 160 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      filter: true,
      editable: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Stop Editing When Grid Loses Focus](https://www.ag-grid.com/archive/36.2.0/examples/cell-editing-start-stop/stop-edit-when-grid-loses-focus/vue3/)

> **Note**
>
> Cell Editing can also be performed via Cell Editor Components; please see [Cell Editor Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editors/) for more information.
